]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test/crypto: add_gnupg_home should have ultimate trust on "its own" key
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # Save STDOUT to fd 6 and STDERR to fd 7.
59 exec 6>&1 7>&2
60 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
61 BASH_XTRACEFD=7
62 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
63
64 # Keep the original TERM for say_color and test_emacs
65 ORIGINAL_TERM=$TERM
66
67 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
68 # Otherwise use whatever TERM is currently used so that
69 # users' actual TERM environments are being used in tests.
70 case ${TERM-} in
71         '' | dumb | unknown )
72                 SMART_TERM=vt100 ;;
73         *)
74                 SMART_TERM=$TERM ;;
75 esac
76
77 # For repeatability, reset the environment to known value.
78 LANG=C
79 LC_ALL=C
80 PAGER=cat
81 TZ=UTC
82 TERM=dumb
83 export LANG LC_ALL PAGER TERM TZ
84 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
85 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
86       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
87     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
88     exit 1
89 fi
90 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
91 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
92 TEST_GDB=${TEST_GDB:-gdb}
93 TEST_CC=${TEST_CC:-cc}
94 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
95
96 # Protect ourselves from common misconfiguration to export
97 # CDPATH into the environment
98 unset CDPATH
99
100 unset GREP_OPTIONS
101
102 # For emacsclient
103 unset ALTERNATE_EDITOR
104
105 add_gnupg_home ()
106 {
107     local output
108     [ -d ${GNUPGHOME} ] && return
109     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
110     at_exit_function _gnupg_exit
111     mkdir -m 0700 "$GNUPGHOME"
112     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
113     test_debug "cat $GNUPGHOME/import.log"
114     if (gpg --quick-random --version >/dev/null 2>&1) ; then
115         echo quick-random >> "$GNUPGHOME"/gpg.conf
116     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
117         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
118     fi
119     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
120
121     # Change this if we ship a new test key
122     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
123     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
124     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
125 }
126
127 # Each test should start with something like this, after copyright notices:
128 #
129 # test_description='Description of this test...
130 # This test checks if command xyzzy does the right thing...
131 # '
132 # . ./test-lib.sh || exit 1
133
134 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
135                 TERM=$ORIGINAL_TERM &&
136                 export TERM &&
137                 [ -t 1 ] &&
138                 tput bold >/dev/null 2>&1 &&
139                 tput setaf 1 >/dev/null 2>&1 &&
140                 tput sgr0 >/dev/null 2>&1
141         ) &&
142         color=t
143
144 while test "$#" -ne 0
145 do
146         case "$1" in
147         -d|--debug)
148                 debug=t; shift ;;
149         -i|--immediate)
150                 immediate=t; shift ;;
151         -h|--help)
152                 help=t; shift ;;
153         -v|--verbose)
154                 verbose=t; shift ;;
155         -q|--quiet)
156                 quiet=t; shift ;;
157         --with-dashes)
158                 with_dashes=t; shift ;;
159         --no-color)
160                 color=; shift ;;
161         --no-python)
162                 # noop now...
163                 shift ;;
164         --valgrind)
165                 valgrind=t; verbose=t; shift ;;
166         --tee)
167                 shift ;; # was handled already
168         *)
169                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
170         esac
171 done
172
173 if test -n "$debug"; then
174     print_subtest () {
175         printf " %-4s" "[$((test_count - 1))]"
176     }
177 else
178     print_subtest () {
179         true
180     }
181 fi
182
183 if test -n "$color"; then
184         say_color () {
185                 (
186                 TERM=$ORIGINAL_TERM
187                 export TERM
188                 case "$1" in
189                         error) tput bold; tput setaf 1;; # bold red
190                         skip)  tput bold; tput setaf 2;; # bold green
191                         pass)  tput setaf 2;;            # green
192                         info)  tput setaf 3;;            # brown
193                         *) test -n "$quiet" && return;;
194                 esac
195                 shift
196                 printf " "
197                 printf "$@"
198                 tput sgr0
199                 print_subtest
200                 )
201         }
202 else
203         say_color() {
204                 test -z "$1" && test -n "$quiet" && return
205                 shift
206                 printf " "
207                 printf "$@"
208                 print_subtest
209         }
210 fi
211
212 error () {
213         say_color error "error: $*\n"
214         GIT_EXIT_OK=t
215         exit 1
216 }
217
218 say () {
219         say_color info "$*"
220 }
221
222 test "${test_description}" != "" ||
223 error "Test script did not set test_description."
224
225 if test "$help" = "t"
226 then
227         echo "Tests ${test_description}"
228         exit 0
229 fi
230
231 test_description_printed=
232 print_test_description ()
233 {
234         test -z "$test_description_printed" || return 0
235         echo
236         echo $this_test: "Testing ${test_description}"
237         test_description_printed=1
238 }
239 if [ -z "$NOTMUCH_TEST_QUIET" ]
240 then
241         print_test_description
242 fi
243
244 test_failure=0
245 test_count=0
246 test_fixed=0
247 test_broken=0
248 test_success=0
249
250 declare -a _exit_functions=()
251
252 at_exit_function () {
253         _exit_functions=($1 ${_exit_functions[@]/$1})
254 }
255
256 rm_exit_function () {
257         _exit_functions=(${_exit_functions[@]/$1})
258 }
259
260 _exit_common () {
261         code=$?
262         trap - EXIT
263         set +ex
264         for _fn in ${_exit_functions[@]}; do $_fn; done
265         rm -rf "$TEST_TMPDIR"
266 }
267
268 trap_exit () {
269         _exit_common
270         if test -n "$GIT_EXIT_OK"
271         then
272                 exit $code
273         else
274                 exec >&6
275                 say_color error '%-6s' FATAL
276                 echo " $test_subtest_name"
277                 echo
278                 echo "Unexpected exit while executing $0. Exit code $code."
279                 exit 1
280         fi
281 }
282
283 trap_signal () {
284         _exit_common
285         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
286         exit $code
287 }
288
289 die () {
290         _exit_common
291         exec >&6
292         say_color error '%-6s' FATAL
293         echo " $*"
294         echo
295         echo "Unexpected exit while executing $0."
296         exit 1
297 }
298
299 GIT_EXIT_OK=
300 # Note: TEST_TMPDIR *NOT* exported!
301 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
302 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
303 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
304 trap 'trap_exit' EXIT
305 trap 'trap_signal' HUP INT TERM
306
307 # Deliver a message with emacs and add it to the database
308 #
309 # Uses emacs to generate and deliver a message to the mail store.
310 # Accepts arbitrary extra emacs/elisp functions to modify the message
311 # before sending, which is useful to doing things like attaching files
312 # to the message and encrypting/signing.
313 emacs_deliver_message ()
314 {
315     local subject="$1"
316     local body="$2"
317     shift 2
318     # before we can send a message, we have to prepare the FCC maildir
319     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
320     # eval'ing smtp-dummy --background will set smtp_dummy_pid
321     smtp_dummy_pid=
322     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
323     test -n "$smtp_dummy_pid" || return 1
324
325     test_emacs \
326         "(let ((message-send-mail-function 'message-smtpmail-send-it)
327                (mail-host-address \"example.com\")
328                (smtpmail-smtp-server \"localhost\")
329                (smtpmail-smtp-service \"25025\"))
330            (notmuch-mua-mail)
331            (message-goto-to)
332            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
333            (message-goto-subject)
334            (insert \"${subject}\")
335            (message-goto-body)
336            (insert \"${body}\")
337            $@
338            (notmuch-mua-send-and-exit))"
339
340     # In case message was sent properly, client waits for confirmation
341     # before exiting and resuming control here; therefore making sure
342     # that server exits by sending (KILL) signal to it is safe.
343     kill -9 $smtp_dummy_pid
344     notmuch new >/dev/null
345 }
346
347 # Pretend to deliver a message with emacs. Really save it to a file
348 # and add it to the database
349 #
350 # Uses emacs to generate and deliver a message to the mail store.
351 # Accepts arbitrary extra emacs/elisp functions to modify the message
352 # before sending, which is useful to doing things like attaching files
353 # to the message and encrypting/signing.
354 #
355 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
356 # at the head of the argument list, they are sent directly to "notmuch
357 # new" after message delivery
358 emacs_fcc_message ()
359 {
360     local nmn_args=''
361     while [[ "$1" =~ ^-- ]]; do
362         nmn_args="$nmn_args $1"
363         shift
364     done
365     local subject="$1"
366     local body="$2"
367     shift 2
368     # before we can send a message, we have to prepare the FCC maildir
369     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
370
371     test_emacs \
372         "(let ((message-send-mail-function (lambda () t))
373                (mail-host-address \"example.com\"))
374            (notmuch-mua-mail)
375            (message-goto-to)
376            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
377            (message-goto-subject)
378            (insert \"${subject}\")
379            (message-goto-body)
380            (insert \"${body}\")
381            $@
382            (notmuch-mua-send-and-exit))" || return 1
383     notmuch new $nmn_args >/dev/null
384 }
385
386 # Add an existing, fixed corpus of email to the database.
387 #
388 # $1 is the corpus dir under corpora to add, using "default" if unset.
389 #
390 # The default corpus is based on about 50 messages from early in the
391 # history of the notmuch mailing list, which allows for reliably
392 # testing commands that need to operate on a not-totally-trivial
393 # number of messages.
394 add_email_corpus ()
395 {
396     corpus=${1:-default}
397
398     rm -rf ${MAIL_DIR}
399     if [ -d $TEST_DIRECTORY/corpora.mail/$corpus ]; then
400         cp -a $TEST_DIRECTORY/corpora.mail/$corpus ${MAIL_DIR}
401     else
402         cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
403         notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
404         mkdir -p $TEST_DIRECTORY/corpora.mail
405         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpora.mail/$corpus
406     fi
407 }
408
409 test_begin_subtest ()
410 {
411     if [ -n "$inside_subtest" ]; then
412         exec 1>&6 2>&7          # Restore stdout and stderr
413         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
414     fi
415     test_subtest_name="$1"
416     test_reset_state_
417     # Redirect test output to the previously prepared file descriptors
418     # 3 and 4 (see below)
419     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
420     exec >&3 2>&4
421     inside_subtest=t
422 }
423
424 # Pass test if two arguments match
425 #
426 # Note: Unlike all other test_expect_* functions, this function does
427 # not accept a test name. Instead, the caller should call
428 # test_begin_subtest before calling this function in order to set the
429 # name.
430 test_expect_equal ()
431 {
432         exec 1>&6 2>&7          # Restore stdout and stderr
433         if [ -z "$inside_subtest" ]; then
434                 error "bug in the test script: test_expect_equal without test_begin_subtest"
435         fi
436         inside_subtest=
437         test "$#" = 2 ||
438         error "bug in the test script: not 2 parameters to test_expect_equal"
439
440         output="$1"
441         expected="$2"
442         if ! test_skip "$test_subtest_name"
443         then
444                 if [ "$output" = "$expected" ]; then
445                         test_ok_
446                 else
447                         testname=$this_test.$test_count
448                         echo "$expected" > $testname.expected
449                         echo "$output" > $testname.output
450                         test_failure_ "$(diff -u $testname.expected $testname.output)"
451                 fi
452     fi
453 }
454
455 # Like test_expect_equal, but takes two filenames.
456 test_expect_equal_file ()
457 {
458         exec 1>&6 2>&7          # Restore stdout and stderr
459         if [ -z "$inside_subtest" ]; then
460                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
461         fi
462         inside_subtest=
463         test "$#" = 2 ||
464         error "bug in the test script: not 2 parameters to test_expect_equal_file"
465
466         file1="$1"
467         file2="$2"
468         if ! test_skip "$test_subtest_name"
469         then
470                 if diff -q "$file1" "$file2" >/dev/null ; then
471                         test_ok_
472                 else
473                         testname=$this_test.$test_count
474                         basename1=`basename "$file1"`
475                         basename2=`basename "$file2"`
476                         cp "$file1" "$testname.$basename1"
477                         cp "$file2" "$testname.$basename2"
478                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
479                 fi
480     fi
481 }
482
483 # Like test_expect_equal, but arguments are JSON expressions to be
484 # canonicalized before diff'ing.  If an argument cannot be parsed, it
485 # is used unchanged so that there's something to diff against.
486 test_expect_equal_json () {
487     # The test suite forces LC_ALL=C, but this causes Python 3 to
488     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
489     # override Python's stdio encoding defaults.
490     local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
491     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
492         || echo "$1")
493     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
494         || echo "$2")
495     shift 2
496     test_expect_equal "$output" "$expected" "$@"
497 }
498
499 # Sort the top-level list of JSON data from stdin.
500 test_sort_json () {
501     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
502         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
503 }
504
505 test_emacs_expect_t () {
506         test "$#" = 1 ||
507         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
508         if [ -z "$inside_subtest" ]; then
509                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
510         fi
511
512         # Run the test.
513         if ! test_skip "$test_subtest_name"
514         then
515                 test_emacs "(notmuch-test-run $1)" >/dev/null
516
517                 # Restore state after the test.
518                 exec 1>&6 2>&7          # Restore stdout and stderr
519                 inside_subtest=
520
521                 # Report success/failure.
522                 result=$(cat OUTPUT)
523                 if [ "$result" = t ]
524                 then
525                         test_ok_
526                 else
527                         test_failure_ "${result}"
528                 fi
529         else
530                 # Restore state after the (non) test.
531                 exec 1>&6 2>&7          # Restore stdout and stderr
532                 inside_subtest=
533         fi
534 }
535
536 NOTMUCH_NEW ()
537 {
538     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
539 }
540
541 NOTMUCH_DUMP_TAGS ()
542 {
543     # this relies on the default format being batch-tag, otherwise some tests will break
544     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
545 }
546
547 notmuch_drop_mail_headers ()
548 {
549     $NOTMUCH_PYTHON -c '
550 import email, sys
551 msg = email.message_from_file(sys.stdin)
552 for hdr in sys.argv[1:]: del msg[hdr]
553 print(msg.as_string(False))
554 ' "$@"
555 }
556
557 notmuch_search_sanitize ()
558 {
559     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
560 }
561
562 notmuch_search_files_sanitize ()
563 {
564     notmuch_dir_sanitize
565 }
566
567 notmuch_dir_sanitize ()
568 {
569     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
570 }
571
572 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
573 notmuch_show_sanitize ()
574 {
575     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
576 }
577 notmuch_show_sanitize_all ()
578 {
579     sed \
580         -e 's| filename:.*| filename:XXXXX|' \
581         -e 's| id:[^ ]* | id:XXXXX |' | \
582         notmuch_date_sanitize
583 }
584
585 notmuch_json_show_sanitize ()
586 {
587     sed \
588         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
589         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
590         -e 's|"filename": "signature.asc",||g' \
591         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
592         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
593         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
594 }
595
596 notmuch_emacs_error_sanitize ()
597 {
598     local command=$1
599     shift
600     for file in "$@"; do
601         echo "=== $file ==="
602         cat "$file"
603     done | sed  \
604         -e 's/^\[.*\]$/[XXX]/' \
605         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
606 }
607
608 notmuch_date_sanitize ()
609 {
610     sed \
611         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
612 }
613
614 notmuch_uuid_sanitize ()
615 {
616     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
617 }
618
619 notmuch_built_with_sanitize ()
620 {
621     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
622 }
623
624 notmuch_config_sanitize ()
625 {
626     notmuch_dir_sanitize | notmuch_built_with_sanitize
627 }
628
629 notmuch_show_part ()
630 {
631     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
632 }
633
634 # End of notmuch helper functions
635
636 # Use test_set_prereq to tell that a particular prerequisite is available.
637 #
638 # The prerequisite can later be checked for by using test_have_prereq.
639 #
640 # The single parameter is the prerequisite tag (a simple word, in all
641 # capital letters by convention).
642
643 test_set_prereq () {
644         satisfied="$satisfied$1 "
645 }
646 satisfied=" "
647
648 test_have_prereq () {
649         case $satisfied in
650         *" $1 "*)
651                 : yes, have it ;;
652         *)
653                 ! : nope ;;
654         esac
655 }
656
657 declare -A test_missing_external_prereq_
658 declare -A test_subtest_missing_external_prereq_
659
660 # declare prerequisite for the given external binary
661 test_declare_external_prereq () {
662         binary="$1"
663         test "$#" = 2 && name=$2 || name="$binary(1)"
664
665         if ! hash $binary 2>/dev/null; then
666                 test_missing_external_prereq_["${binary}"]=t
667                 eval "
668 $binary () {
669         test_subtest_missing_external_prereq_[\"${name}\"]=t
670         false
671 }"
672         fi
673 }
674
675 # Explicitly require external prerequisite.  Useful when binary is
676 # called indirectly (e.g. from emacs).
677 # Returns success if dependency is available, failure otherwise.
678 test_require_external_prereq () {
679         binary="$1"
680         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
681                 # dependency is missing, call the replacement function to note it
682                 eval "$binary"
683         else
684                 true
685         fi
686 }
687
688 # You are not expected to call test_ok_ and test_failure_ directly, use
689 # the text_expect_* functions instead.
690
691 test_ok_ () {
692         if test "$test_subtest_known_broken_" = "t"; then
693                 test_known_broken_ok_
694                 return
695         fi
696         test_success=$(($test_success + 1))
697         if test -n "$NOTMUCH_TEST_QUIET"; then
698                 return 0
699         fi
700         say_color pass "%-6s" "PASS"
701         echo " $test_subtest_name"
702 }
703
704 test_failure_ () {
705         print_test_description
706         if test "$test_subtest_known_broken_" = "t"; then
707                 test_known_broken_failure_ "$@"
708                 return
709         fi
710         test_failure=$(($test_failure + 1))
711         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
712         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
713         return 1
714 }
715
716 test_failure_message_ () {
717         say_color error "%-6s" "$1"
718         echo " $2"
719         shift 2
720         if [ "$#" != "0" ]; then
721                 echo "$@" | sed -e 's/^/        /'
722         fi
723         if test "$verbose" != "t"; then cat test.output; fi
724 }
725
726 test_known_broken_ok_ () {
727         test_reset_state_
728         test_fixed=$(($test_fixed+1))
729         say_color pass "%-6s" "FIXED"
730         echo " $test_subtest_name"
731 }
732
733 test_known_broken_failure_ () {
734         test_reset_state_
735         test_broken=$(($test_broken+1))
736         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
737                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
738         else
739                 test_failure_message_ "BROKEN" "$test_subtest_name"
740         fi
741         return 1
742 }
743
744 test_debug () {
745         test "$debug" = "" || eval "$1"
746 }
747
748 test_run_ () {
749         test_cleanup=:
750         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
751         eval >&3 2>&4 "$1"
752         eval_ret=$?
753         eval >&3 2>&4 "$test_cleanup"
754         return 0
755 }
756
757 test_skip () {
758         test_count=$(($test_count+1))
759         to_skip=
760         for skp in $NOTMUCH_SKIP_TESTS
761         do
762                 case $this_test.$test_count in
763                 $skp)
764                         to_skip=t
765                         break
766                 esac
767                 case $this_test_bare.$test_count in
768                 $skp)
769                         to_skip=t
770                         break
771                 esac
772         done
773         case "$to_skip" in
774         t)
775                 test_report_skip_ "$@"
776                 ;;
777         *)
778                 test_check_missing_external_prereqs_ "$@"
779                 ;;
780         esac
781 }
782
783 test_check_missing_external_prereqs_ () {
784         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
785                 say_color skip >&1 "missing prerequisites: "
786                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
787                 test_report_skip_ "$@"
788         else
789                 false
790         fi
791 }
792
793 test_report_skip_ () {
794         test_reset_state_
795         say_color skip >&3 "skipping test:"
796         echo " $@" >&3
797         say_color skip "%-6s" "SKIP"
798         echo " $1"
799 }
800
801 test_subtest_known_broken () {
802         test_subtest_known_broken_=t
803 }
804
805 test_expect_success () {
806         exec 1>&6 2>&7          # Restore stdout and stderr
807         if [ -z "$inside_subtest" ]; then
808                 error "bug in the test script: test_expect_success without test_begin_subtest"
809         fi
810         inside_subtest=
811         test "$#" = 1 ||
812         error "bug in the test script: not 1 parameters to test_expect_success"
813
814         if ! test_skip "$test_subtest_name"
815         then
816                 test_run_ "$1"
817                 run_ret="$?"
818                 # test_run_ may update missing external prerequisites
819                 test_check_missing_external_prereqs_ "$@" ||
820                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
821                 then
822                         test_ok_
823                 else
824                         test_failure_ "$1"
825                 fi
826         fi
827 }
828
829 test_expect_code () {
830         exec 1>&6 2>&7          # Restore stdout and stderr
831         if [ -z "$inside_subtest" ]; then
832                 error "bug in the test script: test_expect_code without test_begin_subtest"
833         fi
834         inside_subtest=
835         test "$#" = 2 ||
836         error "bug in the test script: not 2 parameters to test_expect_code"
837
838         if ! test_skip "$test_subtest_name"
839         then
840                 test_run_ "$2"
841                 run_ret="$?"
842                 # test_run_ may update missing external prerequisites,
843                 test_check_missing_external_prereqs_ "$@" ||
844                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
845                 then
846                         test_ok_
847                 else
848                         test_failure_ "exit code $eval_ret, expected $1" "$2"
849                 fi
850         fi
851 }
852
853 # This is not among top-level (test_expect_success)
854 # but is a prefix that can be used in the test script, like:
855 #
856 #       test_expect_success 'complain and die' '
857 #           do something &&
858 #           do something else &&
859 #           test_must_fail git checkout ../outerspace
860 #       '
861 #
862 # Writing this as "! git checkout ../outerspace" is wrong, because
863 # the failure could be due to a segv.  We want a controlled failure.
864
865 test_must_fail () {
866         "$@"
867         test $? -gt 0 -a $? -le 129 -o $? -gt 192
868 }
869
870 # test_cmp is a helper function to compare actual and expected output.
871 # You can use it like:
872 #
873 #       test_expect_success 'foo works' '
874 #               echo expected >expected &&
875 #               foo >actual &&
876 #               test_cmp expected actual
877 #       '
878 #
879 # This could be written as either "cmp" or "diff -u", but:
880 # - cmp's output is not nearly as easy to read as diff -u
881 # - not all diff versions understand "-u"
882
883 test_cmp() {
884         $GIT_TEST_CMP "$@"
885 }
886
887 # This function can be used to schedule some commands to be run
888 # unconditionally at the end of the test to restore sanity:
889 #
890 #       test_expect_success 'test core.capslock' '
891 #               git config core.capslock true &&
892 #               test_when_finished "git config --unset core.capslock" &&
893 #               hello world
894 #       '
895 #
896 # That would be roughly equivalent to
897 #
898 #       test_expect_success 'test core.capslock' '
899 #               git config core.capslock true &&
900 #               hello world
901 #               git config --unset core.capslock
902 #       '
903 #
904 # except that the greeting and config --unset must both succeed for
905 # the test to pass.
906
907 test_when_finished () {
908         test_cleanup="{ $*
909                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
910 }
911
912 test_done () {
913         GIT_EXIT_OK=t
914         test_results_dir="$TEST_DIRECTORY/test-results"
915         mkdir -p "$test_results_dir"
916         test_results_path="$test_results_dir/$this_test"
917
918         echo "total $test_count" >> $test_results_path
919         echo "success $test_success" >> $test_results_path
920         echo "fixed $test_fixed" >> $test_results_path
921         echo "broken $test_broken" >> $test_results_path
922         echo "failed $test_failure" >> $test_results_path
923         echo "" >> $test_results_path
924
925         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
926
927         if [ "$test_failure" = "0" ]; then
928             if [ "$test_broken" = "0" ]; then
929                 rm -rf "$remove_tmp"
930             fi
931             exit 0
932         else
933             exit 1
934         fi
935 }
936
937 emacs_generate_script () {
938         # Construct a little test script here for the benefit of the user,
939         # (who can easily run "run_emacs" to get the same emacs environment
940         # for investigating any failures).
941         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
942 #!/bin/sh
943 export PATH=$PATH
944 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
945
946 # Here's what we are using here:
947 #
948 # --quick              Use minimal customization. This implies --no-init-file,
949 #                      --no-site-file and (emacs 24) --no-site-lisp
950 #
951 # --directory           Ensure that the local elisp sources are found
952 #
953 # --load                Force loading of notmuch.el and test-lib.el
954
955 exec ${TEST_EMACS} --quick \
956         --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
957         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
958         "\$@"
959 EOF
960         chmod a+x "$TMP_DIRECTORY/run_emacs"
961 }
962
963 test_emacs () {
964         # test dependencies beforehand to avoid the waiting loop below
965         missing_dependencies=
966         test_require_external_prereq dtach || missing_dependencies=1
967         test_require_external_prereq emacs || missing_dependencies=1
968         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
969         test -z "$missing_dependencies" || return
970
971         if [ -z "$EMACS_SERVER" ]; then
972                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
973                 if [ -f "$emacs_tests" ]; then
974                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
975                 else
976                         load_emacs_tests=
977                 fi
978                 server_name="notmuch-test-suite-$$"
979                 # start a detached session with an emacs server
980                 # user's TERM (or 'vt100' in case user's TERM is known dumb
981                 # or unknown) is given to dtach which assumes a minimally
982                 # VT100-compatible terminal -- and emacs inherits that
983                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
984                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
985                                 --no-window-system \
986                                 $load_emacs_tests \
987                                 --eval '(setq server-name \"$server_name\")' \
988                                 --eval '(server-start)' \
989                                 --eval '(orphan-watchdog $$)'" || return
990                 EMACS_SERVER="$server_name"
991                 # wait until the emacs server is up
992                 until test_emacs '()' >/dev/null 2>/dev/null; do
993                         sleep 1
994                 done
995         fi
996
997         # Clear test-output output file.  Most Emacs tests end with a
998         # call to (test-output).  If the test code fails with an
999         # exception before this call, the output file won't get
1000         # updated.  Since we don't want to compare against an output
1001         # file from another test, so start out with an empty file.
1002         rm -f OUTPUT
1003         touch OUTPUT
1004
1005         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $@)"
1006 }
1007
1008 test_python() {
1009     # Note: if there is need to print debug information from python program,
1010     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1011     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1012         $NOTMUCH_PYTHON -B - > OUTPUT
1013 }
1014
1015 test_ruby() {
1016     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1017 }
1018
1019 test_C () {
1020     exec_file="test${test_count}"
1021     test_file="${exec_file}.c"
1022     cat > ${test_file}
1023     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1024     echo "== stdout ==" > OUTPUT.stdout
1025     echo "== stderr ==" > OUTPUT.stderr
1026     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1027     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1028 }
1029
1030
1031 # Creates a script that counts how much time it is executed and calls
1032 # notmuch.  $notmuch_counter_command is set to the path to the
1033 # generated script.  Use notmuch_counter_value() function to get the
1034 # current counter value.
1035 notmuch_counter_reset () {
1036         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1037         if [ ! -x "$notmuch_counter_command" ]; then
1038                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1039                 cat >"$notmuch_counter_command" <<EOF || return
1040 #!/bin/sh
1041
1042 read count < "$notmuch_counter_state_path"
1043 echo \$((count + 1)) > "$notmuch_counter_state_path"
1044
1045 exec notmuch "\$@"
1046 EOF
1047                 chmod +x "$notmuch_counter_command" || return
1048         fi
1049
1050         echo 0 > "$notmuch_counter_state_path"
1051 }
1052
1053 # Returns the current notmuch counter value.
1054 notmuch_counter_value () {
1055         if [ -r "$notmuch_counter_state_path" ]; then
1056                 read count < "$notmuch_counter_state_path"
1057         else
1058                 count=0
1059         fi
1060         echo $count
1061 }
1062
1063 test_reset_state_ () {
1064         test -z "$test_init_done_" && test_init_
1065
1066         test_subtest_known_broken_=
1067         test_subtest_missing_external_prereq_=()
1068 }
1069
1070 # called once before the first subtest
1071 test_init_ () {
1072         test_init_done_=t
1073
1074         # skip all tests if there were external prerequisites missing during init
1075         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1076 }
1077
1078
1079 # Where to run the tests
1080 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1081
1082 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1083
1084 emacs_generate_script
1085
1086
1087 # Use -P to resolve symlinks in our working directory so that the cwd
1088 # in subprocesses like git equals our $PWD (for pathname comparisons).
1089 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1090
1091 if test "$verbose" = "t"
1092 then
1093         exec 4>&2 3>&1
1094 else
1095         exec 4>test.output 3>&4
1096 fi
1097
1098 for skp in $NOTMUCH_SKIP_TESTS
1099 do
1100         to_skip=
1101         for skp in $NOTMUCH_SKIP_TESTS
1102         do
1103                 case "$this_test" in
1104                 $skp)
1105                         to_skip=t
1106                         break
1107                 esac
1108                 case "$this_test_bare" in
1109                 $skp)
1110                         to_skip=t
1111                         break
1112                 esac
1113         done
1114         case "$to_skip" in
1115         t)
1116                 say_color skip >&3 "skipping test $this_test altogether"
1117                 say_color skip "skip all tests in $this_test"
1118                 test_done
1119         esac
1120 done
1121
1122 # Provide an implementation of the 'yes' utility
1123 yes () {
1124         if test $# = 0
1125         then
1126                 y=y
1127         else
1128                 y="$*"
1129         fi
1130
1131         while echo "$y"
1132         do
1133                 :
1134         done
1135 }
1136
1137 # Fix some commands on Windows
1138 case $(uname -s) in
1139 *MINGW*)
1140         # Windows has its own (incompatible) sort and find
1141         sort () {
1142                 /usr/bin/sort "$@"
1143         }
1144         find () {
1145                 /usr/bin/find "$@"
1146         }
1147         sum () {
1148                 md5sum "$@"
1149         }
1150         # git sees Windows-style pwd
1151         pwd () {
1152                 builtin pwd -W
1153         }
1154         # no POSIX permissions
1155         # backslashes in pathspec are converted to '/'
1156         # exec does not inherit the PID
1157         ;;
1158 *)
1159         test_set_prereq POSIXPERM
1160         test_set_prereq BSLASHPSPEC
1161         test_set_prereq EXECKEEPSPID
1162         ;;
1163 esac
1164
1165 test -z "$NO_PERL" && test_set_prereq PERL
1166 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1167
1168 # test whether the filesystem supports symbolic links
1169 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1170 rm -f y
1171
1172 # convert variable from configure to more convenient form
1173 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1174     glass)
1175         db_ending=glass
1176     ;;
1177     chert)
1178         db_ending=DB
1179     ;;
1180     *)
1181         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1182 esac
1183 # declare prerequisites for external binaries used in tests
1184 test_declare_external_prereq dtach
1185 test_declare_external_prereq emacs
1186 test_declare_external_prereq ${TEST_EMACSCLIENT}
1187 test_declare_external_prereq ${TEST_GDB}
1188 test_declare_external_prereq gpg
1189 test_declare_external_prereq openssl
1190 test_declare_external_prereq gpgsm
1191 test_declare_external_prereq ${NOTMUCH_PYTHON}